#!/usr/bin/python -tt
# Copyright 2010 Google Inc.
# Licensed under the Apache License, Version 2.0
# http://www.apache.org/licenses/LICENSE-2.0

# based on
# Google's Python Class
# http://code.google.com/edu/languages/google-python-class/

# Functional programming exercises
# Fill in the code for the functions below. main() is already set up
# to call the functions with a few different inputs,
# printing 'OK' when each function is correct.
# The starter code for each function includes a 'return'
# which is just a placeholder for your code.
# It's ok if you do not complete all the functions, and there
# are some additional functions to try in string2.py.

# A. col
# Given a matrix m and an integer i, return the column i
def col(m,i):
  # +++your code here+++
  return

# B. transpose
# Given a (squared) matrix m, return the transposed matrix.
def transpose(m):
  # +++your code here+++
  return

# C. cases
# Given two strings s1 and s2, return a dict mapping all uppercase
# characters in s1 to their lowercase characters in s2.
# So upper_to_lower('ATGC', 'AtGC') returns {'T': 't'}
def upper_to_lower(s1,s2):
  # +++your code here+++
  return

# D. diag_sum
# Given a matrix m, return the sum of the main diagonal.
def diag_sum(m):
  # +++your code here+++
  return

# Given a matrix m, return true if it is symetric
def isSymetric(m):
  # +++your code here+++
  return

# search in a file for lines matching the given regexp
# return a list of pairs (lineno, match) containing the line number
# of the matching line together with its match object
def grep(filename, regexp):
  # +++your code here+++
  return

# Provided simple test() function used in main() to print
# what each function returns vs. what it's supposed to return.
def test(got, expected):
  if got == expected:
    prefix = ' OK '
  else:
    prefix = '  X '
  print '%s got: %s expected: %s' % (prefix, repr(got), repr(expected))


# Provided main() calls the above functions with interesting inputs,
# using test() to check if each result is correct or not.
def main():
  print 'col'
  test(col([[1,2,3],[3,4,5]],0), [1,3])
  test(col([[1,2],[3,4],[5,6]],1), [2,4,6])

  print
  print 'transpose'
  test(transpose([[1,2],[3,4]]), [[1,3],[2,4]])
  test(transpose([[1,2,3],[3,4,5],[4,5,6]]), [[1,3,4],[2,4,5],[3,5,6]])

  print
  print 'upper_to_lower'
  test(upper_to_lower("ATGTC", "AttGC"), {'T': 't'})
  test(upper_to_lower("ATGTc", "Attgc"), {'T': 't', 'G': 'g'})
  test(upper_to_lower("ATGTC", "ATTGC"), {})
  test(upper_to_lower("", ""), {})

  print
  print 'diag_sum'
  test(diag_sum([[1,2,3],[3,4,5],[5,6,7]]), 12)
  test(diag_sum([[1,2,3],[3,4,5]]), 5)
  test(diag_sum([[1,2],[3,4],[5,6]]), 5)
  test(diag_sum([[]]), 0)

  grep("./uebung2.py", "def ([A-Za-z_][A-Za-z0-9_]+():)")

# Standard boilerplate to call the main() function.
if __name__ == '__main__':
  main()
